-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine.Gameplay";
import "Turbine.UI";
import "Tonic.Utils.Class";
import "Tonic.Utils.Table";

MiscEvents = class( Turbine.Object  );

function MiscEvents:Constructor( regEvents )
	self.registeredEvents = regEvents;
	
	eventManager.AddCallback( self, player, "InCombatChanged", function( sender, args )
		if ( player:IsInCombat() ) then
			self.registeredEvents.playerInCombat = true;
		else
			self.registeredEvents.playerInCombat = false;
		end
		eventManager:NotifyClients();
	end);
	
	eventManager.AddCallback( self, player, "MountChanged", function( sender, args )
		local mount = player:GetMount();
		if ( mount == nil ) then
			self.registeredEvents.playerMounted = false;
			self.registeredEvents.playerCombatMounted = false;
		else
			self.registeredEvents.playerMounted = true;
--			if ( mount == Turbine.)
			self.registeredEvents.playerCombatMounted = false;
--		    end
		end
		eventManager:NotifyClients();
	end);
end

function MiscEvents:CheckVisibility( barSettings )
	local visible = false;
	-- Send all Keypress based events to all clients
	if ( (self.registeredEvents.playerInCombat == true and barSettings.events.displayInCombat == true) or
		 (self.registeredEvents.playerInCombat == false and barSettings.events.displayNotInCombat == true)
		) then
		visible = true;
	end
	-- ToDo -- More here.
	if ( (self.registeredEvents.playerMounted == true and barSettings.events.displayMounted == true) or
		 (self.registeredEvents.playerCombatMounted == true and barSettings.events.displayCombatMounted == true)
		) then
		visible = true;
	end
	return visible;
end